package fi.em.formPlugin;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.exception.KDBizException;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;
import org.apache.commons.lang.StringUtils;

import java.math.BigDecimal;
import java.util.*;
public class YFListtenerFromPlugin extends AbstractBillPlugIn implements Plugin, BeforeF7SelectListener {
    private final static String paycompany="paycompany";//预付借款单 共享中心

//业务处理单基础资料过滤插件


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit fieldEdit21 = this.getView().getControl(paycompany);
        fieldEdit21.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        String fieldKey = beforeF7SelectEvent.getProperty().getName();
        int row = beforeF7SelectEvent.getRow();
                if (StringUtils.equals(fieldKey, paycompany)){
            this.getQFiltergxzx(beforeF7SelectEvent,paycompany);
        }
    }
        private void getQFiltergxzx(BeforeF7SelectEvent arg0, String type) {
        DynamicObject data = (DynamicObject)this.getModel().getValue("costcompany") ;
        if(data ==null){
            throw new KDBizException("核算组织为空！");
        }
        String number = data.getString("number");
        QFilter filter;
        //给基础资料添加过滤
        filter = new QFilter("fromorg.number", QCP.equals, number);
        filter.and("typerelation.number", QCP.equals,"accounting2capital");
            Map<Object, DynamicObject> objectDynamicObjectMap = BusinessDataServiceHelper.loadFromCache("bos_org_orgrelation", new QFilter[]{filter});
            for(Object idkey:objectDynamicObjectMap.keySet()){
                DynamicObject dynamicObject = objectDynamicObjectMap.get(idkey);
                DynamicObject toorg = dynamicObject.getDynamicObject("toorg");
                String numbers = toorg.getString("number");
                QFilter number1 = new QFilter("number", QCP.equals, numbers);
                ListShowParameter showParameter = (ListShowParameter)arg0.getFormShowParameter();
                showParameter.getListFilterParameter().setFilter(number1);
            }
    }
}
