package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

//资产拆分单
public class AssetSplitBillOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
            DynamicObject assetsplitentry = info.getDynamicObjectCollection("assetsplitentry").get(0);
            //获取拆分后分录
            DynamicObjectCollection subassetsplitentry = assetsplitentry.getDynamicObjectCollection("subassetsplitentry");
            if (StringUtils.equals(e.getOperationKey(),"audit")) {
                for (DynamicObject object : subassetsplitentry) {
                    //拆分后分录实物卡片清单字段
                    DynamicObject nckd_real_card_list = object.getDynamicObject("nckd_real_card_list");
                    if (nckd_real_card_list != null) {
                        //查询实物卡片
                        String aft_cardnumber = object.getString("aft_cardnumber");
                        QFilter filter = new QFilter("number", QCP.equals,aft_cardnumber);
                        filter.and("isbak", QCP.equals, "0");
                        DynamicObject[] card = BusinessDataServiceHelper.load("fa_card_real","id",new QFilter[] {filter});
                        DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(card[0].getPkValue(), card[0].getDynamicObjectType().getName());

                        //实物卡片表头多选基础资料赋值
                        cardInfo.getDynamicObjectCollection("nckd_real_card").clear();
                        cardInfo.getDynamicObjectCollection("nckd_real_card").addNew().set("fbasedataid",nckd_real_card_list);

                        //实物卡片分录明细赋值
                        DynamicObjectCollection nckd_realcard_list = cardInfo.getDynamicObjectCollection("nckd_realcard_list");
                        nckd_realcard_list.clear();
                        nckd_realcard_list.addNew().set("nckd_card_code21", nckd_real_card_list);
                        SaveServiceHelper.save(new DynamicObject[]{cardInfo});

                        //e管家实物卡片
                        QFilter efilter = new QFilter("id", QCP.equals,nckd_real_card_list.getLong("id"));
                        DynamicObject[] cardList = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {efilter});
                        DynamicObject eCard = BusinessDataServiceHelper.loadSingle(cardList[0].getPkValue(), cardList[0].getDynamicObjectType().getName());
                        eCard.set("nckd_card_real_code", aft_cardnumber);
                        SaveServiceHelper.save(new DynamicObject[]{eCard});
                    }
                }
            } else if (StringUtils.equals(e.getOperationKey(),"unaudit")) {
                DynamicObject realcard = assetsplitentry.getDynamicObject("realcard");
                //查询实物卡片
                QFilter filter = new QFilter("number", QCP.equals,realcard.getString("number"));
                filter.and("isbak", QCP.equals, "0");
                DynamicObject[] card = BusinessDataServiceHelper.load("fa_card_real","id",new QFilter[] {filter});
                DynamicObject cardInfo = BusinessDataServiceHelper.loadSingle(card[0].getPkValue(), card[0].getDynamicObjectType().getName());
                cardInfo.getDynamicObjectCollection("nckd_real_card").clear();
                cardInfo.getDynamicObjectCollection("nckd_realcard_list").clear();
                for (DynamicObject object : subassetsplitentry) {
                    //拆分后分录实物卡片清单字段
                    DynamicObject nckd_real_card_list = object.getDynamicObject("nckd_real_card_list");
                    if (nckd_real_card_list != null) {

                        cardInfo.getDynamicObjectCollection("nckd_real_card").addNew().set("fbasedataid",nckd_real_card_list);

                        cardInfo.getDynamicObjectCollection("nckd_realcard_list").addNew().set("nckd_card_code21", nckd_real_card_list);

                        //e管家实物卡片
                        QFilter efilter = new QFilter("id", QCP.equals,nckd_real_card_list.getLong("id"));
                        DynamicObject[] cardList = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {efilter});
                        DynamicObject eCard = BusinessDataServiceHelper.loadSingle(cardList[0].getPkValue(), cardList[0].getDynamicObjectType().getName());
                        eCard.set("nckd_card_real_code", realcard.getString("number"));
                        SaveServiceHelper.save(new DynamicObject[]{eCard});
                    }
                }
                SaveServiceHelper.save(new DynamicObject[]{cardInfo});
            }
        }
    }
}
